#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void show_state(int s[][3]);
int check_state(int s[][3]);
void computer_step(int s[][3], int computer, int *step_i, int *step_j);

int main(void)
{ 
  int state[3][3] = {0};
  int computer;             // 1: o, first; 2: x, second.
  int player;
  int turn;                 // 1: computer, 0: player.
  int i, j, k;
  char ch;  
  
  srand((unsigned)time(NULL));

  
  printf("Play first? (y (yes) or n (no)) ");
  scanf("%c", &ch);
  if (ch == 'y')
  {
     computer = 2;
     player = 1;
     turn = 0;
  }
  else
  {
     computer = 1;
     player = 2;
     turn = 1;
  }
  //
  while (check_state(state) == 0)
  {
     if (turn == 0)
     {
        printf("Enter your next step (x x, between 0 and 2): ");
        scanf("%d%d", &i, &j);
        while (i < 0 || i > 2 || j < 0 || j > 2 || state[i][j] != 0)
        {
          printf("Position (%d,%d) is not valid.\n", i, j);   
          printf("Enter your next step (x x, between 0 and 2): ");
          scanf("%d%d", &i, &j);
        }
        state[i][j] = player;   
     }
     else
     {
        computer_step(state, computer, &i, &j);
        state[i][j] = computer;   
     }
     //
	 printf("\n");
     show_state(state);
     //
     i = check_state(state);
     if (i == computer)
     {
        printf("Computer wins!!!\n");
        break;
     }
     else if (i == player)
     {
        printf("You win!!!\n");
        break;
     }
     // check if empty positions exist
     k = 0;
     for (i=0; i < 3; i++)
         for (j=0; j < 3; j++)
         {
             if (state[i][j] == 0)
             {
                 k = 1;
                 break;
             }
         }
     if (k == 0)
     {
        printf("You and computer tie!!!\n");
        break;
     }
     //
     turn = 1-turn;
  }
     
  return 0;
}

void show_state(int s[][3])
{
  int i, j;   
  for (i=0; i < 3; i++)
  {    
      for (j=0; j < 3; j++)
      {
          if (s[i][j] == 1)
             printf("O ");
          else if (s[i][j] == 2)
             printf("X ");
          else
             printf(". ");
      }
      printf("\n");
  }        
}
  
int check_state(int s[][3])
{
    int i, j;
    int flag = 0;
    // cheack rows
    for (i=0; i < 3; i++)
    {
        if (s[i][0] != 0 && s[i][0] == s[i][1] && s[i][1] == s[i][2])
        {
            flag = s[i][0];
            break;
        }
    }
    // check columns
    if (flag == 0)
    {
       for (j=0; j < 3; j++)
       {
           if (s[0][j] != 0 && s[0][j] == s[1][j] && s[1][j] == s[2][j])
           {
              flag = s[0][j];
              break;
           }
       }
    }
    // check diagnol
    if (flag == 0)
    {
       if (s[0][0] != 0 && s[0][0] == s[1][1] && s[1][1] == s[2][2])        
           flag = s[0][0];
       if (s[0][2] != 0 && s[0][2] == s[1][1] && s[1][1] == s[2][0])        
           flag = s[0][2];
    }
    
    return flag;       
}

void computer_step(int s[][3], int computer, int *step_i, int *step_j)
{
     int i, j;
     
     do
     {
       i = rand()%3;
       j = rand()%3;
     }
     while (s[i][j] != 0);
     *step_i = i;
     *step_j = j;
}
